/*!
 * fetch-please v0.1.0
 * HTTP-transport that supports Promises and cancelable requests (XHR)
 * @author Alexander Burtsev, https://github.com/albburtsev
 */
!function(e,t){"object"==typeof exports&&"object"==typeof module?module.exports=t():"function"==typeof define&&define.amd?define([],t):"object"==typeof exports?exports.FetchPlease=t():e.FetchPlease=t()}(this,function(){return function(e){function t(r){if(n[r])return n[r].exports;var u=n[r]={exports:{},id:r,loaded:!1};return e[r].call(u.exports,u,u.exports,t),u.loaded=!0,u.exports}var n={};return t.m=e,t.c=n,t.p="",t(0)}([function(e,t,n){(function(e){"use strict";function r(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}Object.defineProperty(t,"__esModule",{value:!0});var u=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(t,n,r){return n&&e(t.prototype,n),r&&e(t,r),t}}(),a=n(1),o="GET";t.HTTP_METHOD_GET=o;var s="PUT";t.HTTP_METHOD_PUT=s;var i="POST";t.HTTP_METHOD_POST=i;var l="DELETE";t.HTTP_METHOD_DELETE=l;var c=[o,s,i,l];t.ALLOWED_METHODS=c;var d="application/json";t.CONTENT_TYPE_JSON=d;var f=200;t.MIN_SUCCESSFUL_HTTP_CODE=f;var v=299;t.MAX_SUCCESSFUL_HTTP_CODE=v;var h="Constructor XMLHttpRequest not found";t.ERROR_XHR_NOT_FOUND=h;var m="Constructor Promise not found";t.ERROR_PROMISE_NOT_FOUND=m;var g="Unknown HTTP method";t.ERROR_UNKNOWN_HTTP_METHOD=g;var p="Unacceptable HTTP code";t.ERROR_UNACCEPTABLE_HTTP_CODE=p;var E="Invalid data for sending";t.ERROR_INVALID_DATA=E;var R="Invalid JSON";t.ERROR_JSON_PARSE=R;var O="Connection timeout";t.ERROR_CONNECTION_TIMEOUT=O;var T="Resource has been aborted";t.ERROR_RESOURCE_ABORTED=T;var _="Resource failed to load";t.ERROR_RESOURCE_FAILED=_;var y=function(){function t(){var n=arguments.length<=0||void 0===arguments[0]?"":arguments[0],u=arguments.length<=1||void 0===arguments[1]?{}:arguments[1];r(this,t),this.path=n,this.opened=[],a.assign(this,{timeout:0,headers:{},XMLHttpRequest:e.XMLHttpRequest},u);var o=this.XMLHttpRequest;o&&(this.cors="withCredentials"in new o)}return u(t,[{key:"request",value:function(t,n){var r=this,u=arguments.length<=2||void 0===arguments[2]?null:arguments[2],o=arguments.length<=3||void 0===arguments[3]?null:arguments[3];if(!this.XMLHttpRequest)throw new Error(h);if(!e.Promise)throw new Error(m);if(-1===c.indexOf(t))throw new Error(g);var s=new this.XMLHttpRequest,i=new Promise(function(e,t){s.addEventListener("error",function(){return t(_)}),s.addEventListener("abort",function(){return t(T)}),s.addEventListener("timeout",function(){return t(O)}),s.addEventListener("load",function(){s.status&&e(s)})});o=o||{};var l=o.handleJson||this.handleJson,d=o.handleError||this.handleError,f=o.handleResponse||this.handleResponse;i=i.then(function(){return r.close(s)},function(e){throw r.close(s),new Error(e)}).then(f).then(l).catch(d);var v=this.path+n;s.open(t,v);var p=a.assign({},"function"==typeof this.headers?this.headers():this.headers,o.headers);this.setHeaders(s,p);var E=this.timeout||o.timeout||0;return s.timeout=E,u=this.serialize(u),s.send(u),this.add(s),{xhr:s,promise:i}}},{key:"serialize",value:function(t){if(e.FormData&&t instanceof FormData)return t;if(e.Blob&&t instanceof Blob)return t;if(null===t||"string"==typeof t)return t;try{return JSON.stringify(t)}catch(n){throw new Error(E)}}},{key:"setHeaders",value:function(e){var t=arguments.length<=1||void 0===arguments[1]?{}:arguments[1];return Object.keys(t).reduce(function(e,n){var r=t[n];return r!==!1&&null!==r&&void 0!==r&&e.setRequestHeader(n,r),e},e)}},{key:"abort",value:function(){this.opened.forEach(function(e){return e.abort()})}},{key:"add",value:function(e){this.opened.push(e)}},{key:"close",value:function(e){var t=this.opened.indexOf(e);return-1!==t&&this.opened.splice(t,1),e}},{key:"get",value:function(e,t,n){var r=this.getRequest(e,t,n),u=r.promise;return u}},{key:"put",value:function(e,t,n){var r=this.putRequest(e,t,n),u=r.promise;return u}},{key:"post",value:function(e,t,n){var r=this.postRequest(e,t,n),u=r.promise;return u}},{key:"delete",value:function(e,t,n){var r=this.deleteRequest(e,t,n),u=r.promise;return u}},{key:"getRequest",value:function(e){var t=arguments.length<=1||void 0===arguments[1]?null:arguments[1],n=arguments.length<=2||void 0===arguments[2]?null:arguments[2];return e=a.joinParams(e,t),this.request(o,e,null,n)}},{key:"putRequest",value:function(e,t){var n=arguments.length<=2||void 0===arguments[2]?null:arguments[2];return this.request(s,e,t,n)}},{key:"postRequest",value:function(e,t){var n=arguments.length<=2||void 0===arguments[2]?null:arguments[2];return this.request(i,e,t,n)}},{key:"deleteRequest",value:function(e){var t=arguments.length<=1||void 0===arguments[1]?null:arguments[1],n=arguments.length<=2||void 0===arguments[2]?null:arguments[2];return e=a.joinParams(e,t),this.request(l,e,null,n)}},{key:"handleJson",value:function(e){var t=e.responseText,n=e.getResponseHeader("Content-Type")||"";if(n=n.toLowerCase(),-1!==n.indexOf(d))try{return JSON.parse(t)}catch(r){throw new Error(R)}return e}},{key:"handleResponse",value:function(e){var t=e.status;if(f>t||t>v)throw new Error(p);return e}},{key:"handleError",value:function(e){throw new Error(e.message)}}]),t}();t.default=y}).call(t,function(){return this}())},function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default={assign:function(e){for(var t=1;t<arguments.length;t++)for(var n=Object(arguments[t]),r=Object.keys(n),u=0;u<r.length;u++){var a=r[u];n.hasOwnProperty(a)&&(e[a]=n[a])}return e},joinParams:function(e){var t=arguments.length<=1||void 0===arguments[1]?null:arguments[1];if(!t)return e;var n=Object.keys(t).filter(function(e){var n=t[e];return n!==!1&&null!==n&&void 0!==n}).map(function(e){var n=t[e].toString();return e=encodeURIComponent(e),n=encodeURIComponent(n),e+"="+n}).join("&");return n?(e=e.replace(/\?+$/,""),e+(-1===e.indexOf("?")?"?":"&")+n):e}},e.exports=t.default}])});